summaryrefslogtreecommitdiffstats
path: root/tools
diff options
context:
space:
mode:
authorChetan Risbud <crisbud@redhat.com>2014-02-06 16:04:40 +0530
committerLuis Pabon <lpabon@redhat.com>2014-03-14 11:56:15 -0700
commit2505d8281593730d8b31794d0fe8132417c34a48 (patch)
tree6179930dffe024413f7acb340965b30a71d2754a /tools
parent73aa6e788398e0c25e6dd527f968f5ce4b433e79 (diff)
Functional tests for SwiftKerbAuth filter.
This provides an infrastructure for swiftkerbauth related functional test cases. More test cases will be added later. Added a section in swiftkerbauth guide about how to run functional tests. test/functional_auth/swiftkerbauth ---------------------------------- A new authentication filter related functional tests and configuration to reside here. The configuration would help setup the environment. All the generic functional tests should run fine with PASSIVE mode of swiftkerbatuh. Please refere to swiftkerbatuh documentation for ACTIVE/PASSIVE mode of working. swiftkerbauth/test_swkrbath_active.py ------------------------------------- This file has all the testcases of active mode of swiftkerbauth. More test cases to be added later. SwiftKerbAuth related test cases are meant to run on the setup where SwiftKerbAuth is setup and installed. Change-Id: Ibc2a3945f5c9b6714475fcec0ee9d153debb48e3 Signed-off-by: Chetan Risbud <crisbud@redhat.com> Reviewed-on: http://review.gluster.org/6925 Reviewed-by: Luis Pabon <lpabon@redhat.com> Tested-by: Luis Pabon <lpabon@redhat.com>
Diffstat (limited to 'tools')
-rwxr-xr-xtools/swkrbath_functional_tests.sh102
1 files changed, 102 insertions, 0 deletions
diff --git a/tools/swkrbath_functional_tests.sh b/tools/swkrbath_functional_tests.sh
new file mode 100755
index 0000000..7abfd18
--- /dev/null
+++ b/tools/swkrbath_functional_tests.sh
@@ -0,0 +1,102 @@
+#!/bin/bash
+
+# Copyright (c) 2014 Red Hat, Inc.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+# implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+# This program expects to be run by tox in a virtual python environment
+# so that it does not pollute the host development system
+
+sudo_env()
+{
+ sudo bash -c "PATH=$PATH $*"
+}
+
+cleanup()
+{
+ sudo service memcached stop
+ sudo_env swift-init main stop
+ sudo rm -rf /etc/swift > /dev/null 2>&1
+ for acct in /mnt/gluster-object/* ; do
+ sudo rm -rf /mnt/gluster-object/${acct}/* > /dev/null 2>&1
+ sudo setfattr -x user.swift.metadata /mnt/gluster-object/${acct} > /dev/null 2>&1
+ done
+}
+
+quit()
+{
+ echo "$1"
+ exit 1
+}
+
+
+fail()
+{
+ cleanup
+ quit "$1"
+}
+
+### MAIN ###
+
+# Only run if there is no configuration in the system
+if [ -x /etc/swift ] ; then
+ quit "/etc/swift exists, cannot run functional tests."
+fi
+
+# Check the directories exist
+DIRS="/mnt/gluster-object /mnt/gluster-object/test /mnt/gluster-object/test2 /mnt/gluster-object/gsmetadata"
+for d in $DIRS ; do
+ if [ ! -x $d ] ; then
+ quit "$d must exist on an XFS or GlusterFS volume"
+ fi
+done
+
+export SWIFT_TEST_CONFIG_FILE=/etc/swift/test.conf
+
+# Install the configuration files
+sudo mkdir /etc/swift > /dev/null 2>&1
+sudo cp -r test/functional_auth/swiftkerbauth/conf/* /etc/swift || fail "Unable to copy configuration files to /etc/swift"
+
+# Create the ring files
+accounts=""
+for acct in /mnt/gluster-object/* ; do
+ acct=`basename $acct`
+ accounts="$acct $accounts"
+done
+sudo_env gluster-swift-gen-builders $accounts || fail "Unable to create ring files"
+
+# Start the services
+sudo service memcached start || fail "Unable to start memcached"
+sudo_env swift-init main start || fail "Unable to start swift"
+
+mkdir functional_tests > /dev/null 2>&1
+
+echo "== SwiftKerbAuth: Functional Tests =="
+
+
+nosetests -v --exe \
+ --with-xunit \
+ --xunit-file functional_tests/gluster-swift-swiftkerbauth-generic-functional-TC-report.xml \
+ --with-html-output \
+ --html-out-file functional_tests/gluster-swift-swiftkerbauth-generic-functional-result.html \
+ test/functional_auth/swiftkerbauth || fail "Functional tests failed"
+#nosetests -v --exe \
+# --with-xunit \
+# --xunit-file functional_tests/gluster-swift-swiftkerbauth-functionalnosetests-TC-report.xml \
+# --with-html-output \
+# --html-out-file functional_tests/gluster-swift-swiftkerbauth-functionalnosetests-result.html \
+# test/functional || fail "Functional-nose tests failed"
+
+cleanup
+exit 0